﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication21
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // All of this could be done in the designer, but I am doing it in 
            // code to make it easier to see what was done. 
            // But this must be done before Binding the grid to the data source so the button is
            // in place before InitializeRow fires. 
            EditorButton button = new EditorButton();
            button.Text = "Click me";
            this.ultraTextEditor1.ButtonsRight.Add(button);
            this.ultraTextEditor1.EditorButtonClick += new EditorButtonEventHandler(ultraTextEditor1_EditorButtonClick);

            this.ultraGrid1.SetDataBinding(this.ultraDataSource1, null);
        }

        void ultraTextEditor1_EditorButtonClick(object sender, EditorButtonEventArgs e)
        {
            UltraGridCell cell = e.Context as UltraGridCell;
            UltraGridRow row = cell.Row;
            MessageBox.Show(string.Format("You clicked on the Status button in row: {0}", row.Index));
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (e.Row.Cells["Status"].Value as string != "Complete")
                e.Row.Cells["Status"].EditorComponent = this.ultraTextEditor1;
            else
                e.Row.Cells["Status"].EditorComponent = null;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["Status"].ButtonDisplayStyle = ButtonDisplayStyle.Always;
        }
    }
}
